
const db = require('../models');
const FileDBApi = require('./file');
const crypto = require('crypto');
const Utils = require('../utils');



const Sequelize = db.Sequelize;
const Op = Sequelize.Op;

module.exports = class Mapper_statsDBApi {
    

    
    static async create(data, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        const mapper_stats = await db.mapper_stats.create(
            {
                id: data.id || undefined,
        
        total_plays: data.total_plays
        ||
        null
            ,
            
        ranked_loved_maps_count: data.ranked_loved_maps_count
        ||
        null
            ,
            
        computed_at: data.computed_at
        ||
        null
            ,
            
            importHash: data.importHash || null,
            createdById: currentUser.id,
            updatedById: currentUser.id,
    },
        { transaction },
    );

        
        await mapper_stats.setMapper( data.mapper || null, {
            transaction,
        });
        

        

        

        return mapper_stats;
    }
    

    static async bulkImport(data, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        // Prepare data - wrapping individual data transformations in a map() method
        const mapper_statsData = data.map((item, index) => ({
                id: item.id || undefined,
                
                total_plays: item.total_plays
            ||
            null
            ,
            
                ranked_loved_maps_count: item.ranked_loved_maps_count
            ||
            null
            ,
            
                computed_at: item.computed_at
            ||
            null
            ,
            
            importHash: item.importHash || null,
            createdById: currentUser.id,
            updatedById: currentUser.id,
            createdAt: new Date(Date.now() + index * 1000),
    }));

        // Bulk create items
        const mapper_stats = await db.mapper_stats.bulkCreate(mapper_statsData, { transaction });

        // For each item created, replace relation files
        

        return mapper_stats;
    }

    static async update(id, data,  options) {
        const currentUser = (options && options.currentUser) || {id: null};
        const transaction = (options && options.transaction) || undefined;
        

        const mapper_stats = await db.mapper_stats.findByPk(id, {}, {transaction});


        

        const updatePayload = {};
        
        if (data.total_plays !== undefined) updatePayload.total_plays = data.total_plays;
        
        
        if (data.ranked_loved_maps_count !== undefined) updatePayload.ranked_loved_maps_count = data.ranked_loved_maps_count;
        
        
        if (data.computed_at !== undefined) updatePayload.computed_at = data.computed_at;
        
        
        updatePayload.updatedById = currentUser.id;

        await mapper_stats.update(updatePayload, {transaction});

        
        
        if (data.mapper !== undefined) {
            await mapper_stats.setMapper(
              
              data.mapper,
              
              { transaction }
            );
        }
        

        
        

        

        return mapper_stats;
    }

    static async deleteByIds(ids, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        const mapper_stats = await db.mapper_stats.findAll({
            where: {
                id: {
                    [Op.in]: ids,
                },
            },
            transaction,
        });

        await db.sequelize.transaction(async (transaction) => {
            for (const record of mapper_stats) {
                await record.update(
                    {deletedBy: currentUser.id},
                    {transaction}
                );
            }
            for (const record of mapper_stats) {
                await record.destroy({transaction});
            }
        });


        return mapper_stats;
    }

    static async remove(id, options) {
        const currentUser = (options && options.currentUser) || {id: null};
        const transaction = (options && options.transaction) || undefined;

        const mapper_stats = await db.mapper_stats.findByPk(id, options);

        await mapper_stats.update({
            deletedBy: currentUser.id
        }, {
            transaction,
        });

        await mapper_stats.destroy({
            transaction
        });

        return mapper_stats;
    }

    static async findBy(where, options) {
        const transaction = (options && options.transaction) || undefined;

        const mapper_stats = await db.mapper_stats.findOne(
            { where },
            { transaction },
        );

        if (!mapper_stats) {
            return mapper_stats;
        }

        const output = mapper_stats.get({plain: true});

        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        output.mapper = await mapper_stats.getMapper({
            transaction
        });
        
        

        return output;
    }

    static async findAll(
          filter,
           options
        ) {
        const limit = filter.limit || 0;
        let offset = 0;
        let where = {};
        const currentPage = +filter.page;

        

        

        offset = currentPage * limit;

        const orderBy = null;

    const transaction = (options && options.transaction) || undefined;

    let include = [

      {
        model: db.mappers,
        as: 'mapper',
        
        where: filter.mapper ? {
          [Op.or]: [
            { id: { [Op.in]: filter.mapper.split('|').map(term => Utils.uuid(term)) } },
            {
              osu_username: {
                [Op.or]: filter.mapper.split('|').map(term => ({ [Op.iLike]: `%${term}%` }))
              }
            },
          ]
        } : {},
        
      },



    ];

        if (filter) {
            if (filter.id) {
                where = {
                    ...where,
                    ['id']: Utils.uuid(filter.id),
                };
            }

            

            
            

            
            if (filter.total_playsRange) {
                const [start, end] = filter.total_playsRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                    total_plays: {
                    ...where.total_plays,
                            [Op.gte]: start,
                    },
                };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                    total_plays: {
                    ...where.total_plays,
                            [Op.lte]: end,
                    },
                };
                }
            }
            
            if (filter.ranked_loved_maps_countRange) {
                const [start, end] = filter.ranked_loved_maps_countRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                    ranked_loved_maps_count: {
                    ...where.ranked_loved_maps_count,
                            [Op.gte]: start,
                    },
                };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                    ranked_loved_maps_count: {
                    ...where.ranked_loved_maps_count,
                            [Op.lte]: end,
                    },
                };
                }
            }
            
            if (filter.computed_atRange) {
                const [start, end] = filter.computed_atRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                    computed_at: {
                    ...where.computed_at,
                            [Op.gte]: start,
                    },
                };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                    computed_at: {
                    ...where.computed_at,
                            [Op.lte]: end,
                    },
                };
                }
            }
            

            if (filter.active !== undefined) {
                where = {
                    ...where,
                    active: filter.active === true || filter.active === 'true'
                };
            }

            


      



            if (filter.createdAtRange) {
                const [start, end] = filter.createdAtRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                        ['createdAt']: {
                            ...where.createdAt,
                            [Op.gte]: start,
                        },
                    };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                        ['createdAt']: {
                            ...where.createdAt,
                            [Op.lte]: end,
                        },
                    };
                }
            }
        }
        

        

        const queryOptions = {
            where,
            include,
            distinct: true,
            order: filter.field && filter.sort
                ? [[filter.field, filter.sort]]
                : [['createdAt', 'desc']],
            transaction: options?.transaction,
            logging: console.log
        };

        if (!options?.countOnly) {
            queryOptions.limit = limit ? Number(limit) : undefined;
            queryOptions.offset = offset ? Number(offset) : undefined;
        }

        try {
            const { rows, count } = await db.mapper_stats.findAndCountAll(queryOptions);

            return {
                rows: options?.countOnly ? [] : rows,
                count: count
            };
        } catch (error) {
            console.error('Error executing query:', error);
            throw error;
        }
    }

    static async findAllAutocomplete(query, limit, offset, ) {
        let where = {};
        
        

        if (query) {
            where = {
                [Op.or]: [
                    { ['id']: Utils.uuid(query) },
                    Utils.ilike(
                        'mapper_stats',
                        'computed_at',
                        query,
                    ),
                ],
            };
        }

        const records = await db.mapper_stats.findAll({
            attributes: [ 'id', 'computed_at' ],
            where,
            limit: limit ? Number(limit) : undefined,
            offset: offset ? Number(offset) : undefined,
            orderBy: [['computed_at', 'ASC']],
        });

        return records.map((record) => ({
            id: record.id,
            label: record.computed_at,
        }));
    }

    
};

